﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Diagrams;

namespace ClassDiagram
{
    public class PropertyContainer : MyBaseContainer
    {
        private double offsetY = 0d;

        protected override void OnItemsCollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {
            if (e.Action == System.Collections.Specialized.NotifyCollectionChangedAction.Add)
            {
                var diagram = this.Diagram as RadDiagram;
                if (diagram != null) diagram.DeselectAll();
                foreach (var item in e.NewItems.OfType<RadDiagramShapeBase>())
                {
                    var bounds = this.ContentBounds == Rect.Empty ? this.Bounds : this.ContentBounds;
                    var offset = bounds.Y == this.Position.Y ? Constants.RowHeight : bounds.Y - this.Position.Y;
                    item.Position = new Point(bounds.X, this.Position.Y + offset + this.offsetY);
                    item.Width = this.Width;
                    this.offsetY += item.ActualBounds.Height != 0 ? item.ActualBounds.Height : Constants.RowHeight;
                }
            }
            else if (e.Action == System.Collections.Specialized.NotifyCollectionChangedAction.Remove)
            {
            }

            base.OnItemsCollectionChanged(sender, e);
        }

        protected override void OnSizeChanged(Size newSize, Size oldSize)
        {
            base.OnSizeChanged(newSize, oldSize);
            var classShape = this.ParentContainer as ClassShape;
            if (classShape != null)
            {
                classShape.UpdatePositions(this, newSize.Height - oldSize.Height);
                classShape.UpdateContentBounds();
            }
        }
    }
}
